var rolesGrid = Ext.getCmp('{{ component.grid.client_id }}');
var rolesSM = rolesGrid.getSelectionModel();

function addRoleToRole(roleId, parentId) {
    Ext.Ajax.request({
        url: '{{ component.pack.add_role_to_role_action.absolute_url }}',
        params: {
            '{{ component.pack.id_param_name }}': roleId,
            'parent_id': parentId,
        },
        success: function(response, options) {
            smart_eval(response.responseText);
            rolesGrid.refreshStore();
        },
        failure: function (response, options) {
            uiAjaxFailMessage();
        }
    });
}

function topBarAddToRole() {
    var selectedNode = rolesSM.getSelectedNode();

    if (selectedNode) {
        var roleId = selectedNode.id;

        Ext.Ajax.request({
            url: '{{ component.pack.add_role_to_role_window_action.absolute_url }}',
            params: {
                '{{ component.pack.id_param_name }}': roleId,
                'select_mode': true,
            },
            success: function (response, options) {
                var selectWindow = smart_eval(response.responseText);
                selectWindow.on('closed_ok', function (parentId, displayText) {
                    addRoleToRole(roleId, parentId);
                });
            },
        });
    } else {
        Ext.Msg.alert('Добавить в роль', 'Элемент не выбран');
    }
}

function topBarDeleteFromRole() {
    var selectedNode = rolesSM.getSelectedNode();

    if (selectedNode && selectedNode.parentNode) {
        var roleId = selectedNode.id;
        var parentId = selectedNode.parentNode.id;

        Ext.Ajax.request({
            url: '{{ component.pack.delete_role_from_role_action.absolute_url }}',
            params: {
                '{{ component.pack.id_param_name }}': roleId,
                'parent_id': parentId,
            },
            success: function(response, options) {
                smart_eval(response.responseText);
                rolesGrid.refreshStore();
            },
            failure: function (response, options) {
                uiAjaxFailMessage();
            }
        });
    } else {
        Ext.Msg.alert('Удалить из роли', 'Элемент не выбран');
    }
}
